<?php
/***************************************************************************
phpTrafficA @soft.ZoneO.net
Copyright (C) 2004-2005 ZoneO-soft, S. Merkel (dude@zoneo.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/

/*********************************************************************************/
/* Function: echodebug
/* Role: Saves a debug string in error file
/* Parameters:
/*   - the error string
/* Output:
/*   - Nothing
/* Create: 02/2005
/*********************************************************************************/
function echodebug($string) {
	global $path;
	$errors = fopen("$path/errors.dat",'a');
	fwrite($errors,"$string");
	fclose($errors);
}

/*********************************************************************************/
/* Function: getmicrotime
/* Role: time with milliseconds
/* Parameters:
/* Output:
/*   - returns the time
/* Source: php website
/*********************************************************************************/
function getmicrotime()  {
	global $DEBUG;
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}

/*********************************************************************************/
/* Function: clean text
/* Role: clean up text from ' and " to it does not fucks up php strings
/* Parameters:
/*   - $text: the text to be cleaned up
/* Output:
/*   - returns the clean text
/* Created 05/2004
/*********************************************************************************/
function cleanText($text) {
	global $DEBUG;
	$text = str_replace("\'", "&#39", $text);
	$text = str_replace("'", "&#39", $text);
	$text = str_replace("\"", "&#34", $text);
	$text = str_replace("\\\"", "&#34", $text);
	$text = str_replace("\\", "&#92", $text);
	$text = str_replace("\\\\", "&#92", $text);
	return $text;
}

/*********************************************************************************/
/* Function: addBP_LDC
/* Role: add entry in a label-month-count database (monthly count)
/*         if label-month exists: count=count+1
/*         if not, new line, count=1
/* Parameters:
/*   - $table: table with page id's
/*   - $connection: link with database
/*   - $monthstring: month of entry in yyyy-mm-01 format
/*   - $label: label to be looking for
/* Output:
/*   - return 1 if successful
/*   - return -1 if failed
/* Created 05/2004
/*********************************************************************************/
function addDB_LDC($table,$connection,$monthstring,$label) {
	global $DEBUG;
	$sql3 = "SELECT id,count FROM `$table` WHERE STRCMP(label,'$label')=0 AND date='$monthstring'";
	$res3 = mysql_query($sql3,$connection);
	if (mysql_num_rows($res3) == 0) {
		$req4 ="INSERT INTO `$table` VALUES ('', '$label', '$monthstring','0')";
		$res4 = mysql_query($req4,$connection);
		if ($res4 != 1) {
			if ($DEBUG == 1) { echodebug("ERROR 1 in function addDB_LDC! Request was $req4");}
			return -1;
		}
		$id = mysql_insert_id();
		$count = 0;
	} else {
		$row2 = mysql_fetch_object($res3);
		$id = $row2->id;
		$count = $row2->count;
	}
	$count += 1;
	$sql3 = "UPDATE `$table` SET count=$count WHERE id='$id'";
	$res3 = mysql_query($sql3,$connection);
	if ($res3 != 1) {
		if ($DEBUG == 1) {echodebug("ERROR 2 in function addDB_LDC! Request was $sql3");}
		return -1;
	}
	return 1;
}

/*********************************************************************************/
/* Function: add_access
/* Role: add entry in a the access database
/*         if label-date exists: count=count+1
/*         if not, new line, count=1
/* Parameters:
/*   - $table: table with page id's
/*   - $connection: link with database
/*   - $datestring: month of entry in yyyy-mm-01 format
/*   - $pageid: label to be looking for
/*   - $how: how did we get to the page
/*          0: unknow, 1: internal link, 2: search engine, 3: referer
/* Output:
/*   - return 1 if successful
/*   - return -1 if failed
/* Created 02/2005 from addBP_LDC
/* THIS FUNCTION IS NOT IN USE AT THE MOMENT! SQL TABLES DO NO MATCH!
/*********************************************************************************/
function add_access($table,$connection,$monthstring,$label, $how=0) {
	global $DEBUG;
	$sql3 = "SELECT id,count,direct,internal,se,ref FROM `$table` WHERE label=$pageid AND date='$datestring'";
	$res3 = mysql_query($sql3,$connection);
	if (mysql_num_rows($res3) == 0) {
		$req4 ="INSERT INTO `$table` VALUES ('', '$label', '$datestring','0','0','0','0')";
		$res4 = mysql_query($req4,$connection);
		if ($res4 != 1) {
			if ($DEBUG == 1) { echodebug("ERROR 1 in function add_access! Request was $req4");}
			return -1;
		}
		$id = mysql_insert_id();
		$count = 0;
		$access[0] = 0;$access[1] = 0;$access[2] = 0;$access[3] = 0;
	} else {
		$row2 = mysql_fetch_object($res3);
		$id = $row2->id;
		$count = $row2->count;
		$access[0] =$row2->direct;
		$access[1] =$row2->internal;
		$access[2] =$row2->se;
		$access[3] =$row2->ref;
	}
	$count += 1;
	$access[$how]+=1;
	$sql3 = "UPDATE `$table` SET count=$count,direct=$access[0], internal=$access[1], se=$access[2], ref=$access[3] WHERE id='$id'";
	$res3 = mysql_query($sql3,$connection);
	if ($res3 != 1) {
		if ($DEBUG == 1) {echodebug("<br>ERROR 2 in function add_access! Request was $sql3");}
return -1;
}
return 1;
}

/*********************************************************************************/
/* Function: pageid
/* Role: lookup page id in the database, and create one if does not exist
/* Parameters: 
/*   - $table: table with page id's 
/*   - $connection: link with database
/*   - $page
/*   - $date: access date (used only with creating new ID)
/* Output: 
/*   - return id if successful
/*   - return -1 if failed
/* Created 05/2004
/*********************************************************************************/
function pageid($table, $connection, $page, $date) {
	global $DEBUG;
	$sql3 = "SELECT id FROM `$table` WHERE STRCMP(name,'$page')=0";
	$res3 = mysql_query($sql3,$connection);
	if (mysql_num_rows($res3) == 0) {
		$req4 ="INSERT INTO `$table` VALUES ('', '$page', '$date')";
		$res4 = mysql_query($req4,$connection);
		if ($res4 != 1) {
			if ($DEBUG == 1) {echodebug("ERROR! Can not set pageid! Query was $req4");}
			return -1;
		}
		$pageid = mysql_insert_id();
	} else {
		$row2 = mysql_fetch_object($res3);
		$pageid = $row2->id;
	}
	return $pageid;
}

/*********************************************************************************/
/* Function: updateCount
/* Role: update counter in a simple database (value, count) with no line instertion
/* Parameters: 
/*   - $table: table with logs
/*   - $connection: link with database
/*   - $value: the value to be updated (will do count=count+1 for value = $value)
/* Output: 
/*   - return 1 if successful
/*   - return -1 if failed
/* Created 05/2004
/*********************************************************************************/
function updateCount($table, $connection, $value) {
	global $DEBUG;
	$sql3 = "UPDATE `$table` SET count=count+1 WHERE value=$value";
	$res3 = mysql_query($sql3,$connection);
	if ($res3 != 1) {
		if ($DEBUG == 1) {echodebug("<br>ERROR in function updateCount! <br>Query was $sql3");}
		return -1;
	}
	return 1;
}

/*********************************************************************************/
/* Function: addReferrer
/* Role: add a log of a referrer into the database
/* Parameters: 
/*   - $table: table with referrer logs
/*   - $connection: link with database
/*   - $referer: referrer
/*   - $date: date of the entry in yyyy-mm-dd format
/* Output: 
/*   - return 1 if successful
/*   - return -1 if failed
/* Created 05/2004
/*********************************************************************************/
function addReferrer($table, $connection, $referer, $date,$pageid) {
	global $DEBUG;
	$sql3 = "SELECT id,count FROM `$table` WHERE STRCMP(address,'$referer')=0 AND page=$pageid";
	$res3 = mysql_query($sql3,$connection);
	if (mysql_num_rows($res3) == 0) {
		$req4 ="INSERT INTO `$table` VALUES ('', '$referer', '$pageid', '$date', '$date','0')";
		$res4 = mysql_query($req4,$connection);
		if ($res4 != 1) {
			if ($DEBUG == 1) {echodebug("ERROR in function addReferrer!<br>Query was $sql3");}
			return -1;
		}
		$id = mysql_insert_id();
		$count = 0;
	} else {
		$row2 = mysql_fetch_object($res3);
		$id = $row2->id;
		$count = $row2->count;
	}
	$count += 1;
	$sql3 = "UPDATE `$table` SET count=$count, last='$date' WHERE id=$id";
	$res3 = mysql_query($sql3,$connection);
	if ($res3 != 1) {
		if ($DEBUG == 1) {echodebug("ERROR in function addReferrer!<br>Query was $sql3");}
		return -1;
	}
	return 1;
}

/*********************************************************************************/
/* Function: addSEngine
/* Role: add a log of search engine and keywords into the database
/* Parameters: 
/*   - $table: table with search engine logs
/*   - $connection: link with database
/*   - $engine: search engine name
/*   - $keywords
/*   - $date: date of the entry in yyyy-mm-dd format
/* Output: 
/*   - return 1 if successful
/*   - return -1 if failed
/* Created 05/2004
/*********************************************************************************/
function addSEngine($table, $connection, $engine, $keywords, $date, $pageid) {
	global $DEBUG;
	$sql3 = "SELECT id,count FROM `$table` WHERE STRCMP(engine,'$engine')=0 AND STRCMP(keyword,'$keywords')=0 AND page=$pageid";
	$res3 = mysql_query($sql3,$connection);
	if (mysql_num_rows($res3) == 0) {
		$req4 ="INSERT INTO `$table` VALUES ('', '$engine', '$keywords', '$pageid','$date', '$date','0')";
		$res4 = mysql_query($req4,$connection);
		if ($res4 != 1) {
			if ($DEBUG == 1) {echodebug("ERROR in function addSEngine!<br>Query was $req4");}
			return -1;
		}
		$id = mysql_insert_id();
		$count = 0;
	} else {
		$row2 = mysql_fetch_object($res3);
		$id = $row2->id;
		$count = $row2->count;
	}
	$count += 1;
	$sql3 = "UPDATE `$table` SET count=$count, last='$date' WHERE id=$id";
	$res3 = mysql_query($sql3,$connection);
	if ($res3 != 1) {
		if ($DEBUG == 1) {echodebug("ERROR in function addSEngine!<br>Query was $sql3");}
		return -1;
	}
	return 1;
}

/*********************************************************************************/
/* Function: ExtractAgent
/* Role: extract browser and OS from OS string recorded in the log
/* Parameters:
/*   - $agt: agent and browser string
/*   - $browser_id: array with browser ID's
/*   - $browser_label: array with browser names
/*   - $os_id: array with OS ID's
/*   - $os_label: array with OS names
/* Output: a string like WebBrowser;OS
/*    You can extract OS and WebBrowser using:
/*    list($wb,$os)=split(";",ExtractAgent($HTTP_USER_AGENT));
/*     echo $wb."<br>";
/*     echo $os."<br>";
/* Created 04/2004
/* Inspiration from existing function in ezboo webstats, http://www.ezboo.com
/*********************************************************************************/
function ExtractAgent($agt,$browser_id,$browser_label,$os_id,$os_label) {
	global $DEBUG;
	// Init default values
	$new_agt_browser="???";   // Do not change these ??? . It is used in other scripts
	$new_agt_os="???";        // Do not change these ??? . It is used in other scripts
	// Check for browser
	for ($cpt = 0; $cpt < count($browser_id) ; $cpt++) {
		if (ereg($browser_id[$cpt],$agt)) $new_agt_browser=$browser_label[$cpt];
	}
	// Check for OS
	for ($cpt = 0; $cpt < count($os_id) ; $cpt++) {
		if (ereg($os_id[$cpt],$agt)) $new_agt_os=$os_label[$cpt];
	}
	if ($DEBUG==1) {
		if (($new_agt_browser=="???")||($new_agt_os=="???")) {
			echodebug("Unkown agent or browser: $agt gives $new_agt_browser, $new_agt_os");
		}
	}
	return($new_agt_browser.";".$new_agt_os);   # Systax is=  WebBrowser;OS
}

/*********************************************************************************/
/* Function: ExtractKeywords
/* Role: extract keywords and search engines (SE) from a referrer string
/* Parameters:
/*   - $refurl: referrer string
/*   - $engine_id: array with SE ID's
/*   - $engine_url: array with strings to detect the SE
/*   - $engine_kwd: array with an array of strings to detect the SE keywords
/* Output: a list (keyword1 keyword2... SE)
/* Created 05/2004
/* Inspiration from code at scriptygoddess
/*          http://www.scriptygoddess.com/archives/003277.php
/*          but heavily modified
/*********************************************************************************/
function  ExtractKeywords($refurl,$engine_id,$engine_url,$engine_kwd,$debugit=false) {
	global $DEBUG;
	$engid = "???";
	$engkwd = "???";
	$found = 0;
	// Separate hosts and the rest
	if (ereg('^(.*)\?(.*)',$refurl,$regs)) {
		$refhost=$regs[1];
		$refquery=$regs[2];
	}
	$nSengine = count($engine_url);
	for ($i=0; $i<$nSengine;$i++) {
		// Is url matching the search engine?
		if ($debugit) {
			echo "<br>Checking out $engine_url[$i]";
		}
		if (preg_match("/".$engine_url[$i]."/i", $refhost)) {
			// Look for keywords
			$nKeySearch = count($engin_kwd[$i]);
			foreach($engine_kwd[$i] as $key) {
				if (preg_match('/\b'.$key.'=(.*)(?:&|$)/Ui',$refquery,$regs)) {
					// ok, we have a match, store the SE name
					$engid = $engine_id[$i];
					// look for keywords
					$searched=urldecode($regs[1]);
					// look for a ei=ISO-8859-1 string in the line, for some SE, it
					// means that the kw are encoded in this mode
					if (preg_match("/ei=iso-8859-1/i", $refquery)) {
						$searched = utf8_encode ($searched);
					}
					// Voila SE uses ISO-8859-1
					if (preg_match("/voila/i", $refhost)) {
						$searched = utf8_encode ($searched);
					}
					// Free.fr SE uses ISO-8859-1
					if (preg_match("/freeperso/i", $refhost)) {
						$searched = utf8_encode ($searched);
					}
					$keywords=$searched;
					$engkwd=split(' ',$searched); // split up the keywords
					$found = 1;
					break 2; // Exit the whole loop en SE, we found it...
				}
			}
		}
	}
	if ($found == 1) {
		$engkwd[] = $engid;
		return $engkwd;
	}
	return;
}

/*********************************************************************************/
/* Function: read_config
/* Role: Read configuration table
/* Parameters: 
/*   - $config_table: table name
/*   - $connection: connection to the database
/* Output:
/*   - a table with 
/*        $conf[save_host] = number of hosts to save in hosts history table
/*        $conf[os_id] = list with operating systems ID's
/*        $conf[os_label] = list with operating systems labels
/*        $conf[browser_id] = list with browser ID's
/*        $conf[browser_label] = list with browser labels
/*        $conf[engine_id] = list with search engines ID's
/*        $conf[engine_url] = list with search engines url's
/*        $conf[engine_kwd] = list with search engines keyword parameters
/*        $conf[blacklist] = blacklist for referers
/* Created 05/2004
/*********************************************************************************/
function read_config($config_table, $connection) {
	global $DEBUG;
	// get configuration (browser, OS list, search engines definitions)
	$sql = "SELECT * FROM $config_table";
	$result = mysql_query ($sql,$connection);
	$config = array("x" =>"x");
	while($row = mysql_fetch_array($result)) {
		$config = $config + array($row["variable"] => $row["value"] );
	}
	mysql_free_result ($result);
	// Read the os_list and assign 2 arrays (label and id)
	$buffer = split ("\n",$config[os_list]);
	if (trim(end($buffer)) == "") {array_pop($buffer);}
	$i=0;
	foreach($buffer as $buffer1) {
		list ($os_id[$i], $os_label[$i]) = split ('[|]', $buffer1);
		$i+=1;
	}
	// Read the browser_list and assign 2 arrays (label and id)
	$buffer = split ("\n",$config[browser_list]);
	if (trim(end($buffer)) == "") {array_pop($buffer);}
	$i=0;
	foreach($buffer as $buffer1) {
		list ($browser_id[$i], $browser_label[$i]) = split ('[|]', $buffer1);
		$i+=1;
	}
	// Read search engines and keywords table
	$buffer = split ("\n",$config[search_engines]);
	if (trim(end($buffer)) == "") {array_pop($buffer);}
	$i=0;
	foreach($buffer as $buffer1) {
		list ($engine_id[$i], $engine_url[$i], $keywords) = split ('[|]', $buffer1);
		$engine_kwd[$i] = split ('[:]', $keywords);
		$i+=1;
	}
	// Read number of hosts to be saved
	$save_host = $config[save_host];
	// Read the referrer black list
	$blacklist = split ("\n",$config[blacklist]);
	if (trim(end($blacklist)) == "") {array_pop($blacklist);}

	// Prepare data to return
	$conf[save_host] = $save_host;
	$conf[os_id] = $os_id;
	$conf[os_label] = $os_label;
	$conf[browser_id] = $browser_id;
	$conf[browser_label] = $browser_label;
	$conf[engine_id] = $engine_id;
	$conf[engine_url] = $engine_url;
	$conf[engine_kwd] = $engine_kwd;
	$conf[blacklist] = $blacklist;
	return $conf;
}

/*********************************************************************************/
/* Function: insert_retention_entry
/* Role: Archive a new entry for retention statitics
/* Parameters:
/*   - $table: table to store statistics
/*   - $first: first time of visit
/*   - $last: last time of visit
/*   - $clicks: number of clicks
/*   - $connection: connection to the database
/* Output: none
/* Created 02/2005
/*********************************************************************************/
function insert_retention_entry($table, $first, $last, $clicks,$connection) {
	global $DEBUG;

	// Convert duration of stay to minutes
	$duration = intval(($last-$first)/60);
	$date = date("Y-m-01",$first);
	$sql = "SELECT id,count FROM `$table` WHERE date='$date' AND mode=0 AND length=$duration";
	$res = mysql_query($sql,$connection);
	if (mysql_num_rows($res) == 0) {
		$req4 ="INSERT INTO `$table` VALUES ('', '$date', '0', '$duration', '0')";
		$res4 = mysql_query($req4,$connection);
		if ($res4 != 1) {
			if ($DEBUG == 1) {
				echodebug("\nERROR in function insertretentionentry!<br>Query was $sql3");
			}
			return -1;
		}
		$id = mysql_insert_id();
		$count=0;
	} else {
		$row2 = mysql_fetch_object($res);
		$id = $row2->id;
		$count = $row2->count;
	}
	$count += 1;
	$sql3 = "UPDATE `$table` SET count=$count WHERE id=$id";
	$res3 = mysql_query($sql3,$connection);
	if ($res3 != 1) {
		if ($DEBUG == 1) {
			echodebug ("\nERROR in function insertretentionentry!<br>Query was $sql3");
		}
		return -1;
	}
	// Number of clicks
	$sql = "SELECT id,count FROM `$table` WHERE date='$date' AND mode=1 AND length=$clicks";
	$res = mysql_query($sql,$connection);
	if (mysql_num_rows($res) == 0) {
		$req4 ="INSERT INTO `$table` VALUES ('', '$date', '1', '$clicks', '0')";
		$res4 = mysql_query($req4,$connection);
		if ($res4 != 1) {
			if ($DEBUG == 1) {
				echodebug("\nERROR in function insertretentionentry!<br>Query was $sql3");
			}
			return -1;
		}
		$id = mysql_insert_id();
		$count=0;
	} else {
		$row2 = mysql_fetch_object($res);
		$id = $row2->id;
		$count = $row2->count;
	}
	$count += 1;
	$sql3 = "UPDATE `$table` SET count=$count WHERE id=$id";
	$res3 = mysql_query($sql3,$connection);
	if ($res3 != 1) {
		if ($DEBUG == 1) {
			echodebug("\nERROR in function insertretentionentry!<br>Query was $sql3");
		}
		return -1;
	}
	return 1;
}


/*********************************************************************************/
/* Function: retention_stats
/* Role: Calculates visitors retention statitics
/* Parameters:
/*   - $table: table to store statistics
/*   - $host: IP number of the visitor
/*   - $time: unix timestamp of the visit
/*   - $max_keep_retention: how long shall we keep the
/*        visitors in temporary table after last visit (in seconds)
/*        default: 1800 = 30 minutes
/*   - $connection: connection to the database
/
/* Output: none
/* Created 02/2005
/*********************************************************************************/
function  retention_stats($table_retention, $host,$time,$connection,$max_keep_retention=1800) {
	global $path;
	$tmpfile = "$path/retention.$table_retention.dat";
	//echo "file is $tmpfile";
	if (!file_exists($tmpfile)) {
		touch($tmpfile);
	}
	$stats = file("$tmpfile");
	$newstats =fopen("$tmpfile", "w");
	@flock ($newstats,2);
	$found = FALSE;
	foreach($stats as $log) {
		$log_arr = explode("|>|", $log);
		$ip = $log_arr[0];
		$first = $log_arr[1];
		$last = $log_arr[2];
		$clicks = $log_arr[3];
		if ($first>100) {
			if ($host==$ip) {
				if ($last+$max_keep_retention > $time) {
					$clicks += 1;
					fwrite($newstats,"$ip|>|$first|>|$time|>|$clicks\n");
				} else {
					insert_retention_entry($table_retention, $first, $last, $clicks,$connection);
					fwrite($newstats,"$ip|>|$time|>|$time|>|1\n");
				}
				$found = TRUE;
			} else {
				if ($last+$max_keep_retention > $time) {
					fwrite($newstats,"$ip|>|$first|>|$last|>|$clicks\n");
				} else {
					insert_retention_entry($table_retention, $first, $last, $clicks,$connection);
				}
			}
		}
	}
	if (!$found) {fwrite($newstats,"$host|>|$time|>|$time|>|1\n");};
	@flock ($newstats,3);
	fclose($newstats);
	return 1;
}

/*********************************************************************************/
/* Function: logit
/* Role: logs a access into proper databases
/* Parameters:
/*   - $table: base name for tables
/*   - $site: site being audited
/*   - $page: page accessed
/*   - $ip: ip number of host
/*   - $agent: agent string 
/*   - $time: unix timestamp 
/*   - $referer: referer string
/* Output: none
/* Created 05/2004
/*********************************************************************************/
function logit($table, $site, $page, $ip, $agent, $time, $referer, $debugit=false) {
	global $DEBUG;
	global $server;
	global $user;
	global $password;
	global $base;
	global $config_table;
	global $DOCUMENT_ROOT, $phpTrafficAHome, $path;

	// Defining the path, once for all
	// $path =  "$DOCUMENT_ROOT/$phpTrafficAHome";
	$path =  __FILE__;
	$path = preg_replace( "'\\\log_function\.php'", "", $path);
	$path = preg_replace( "'/log_function\.php'", "", $path);
	//
	$timestart = getmicrotime();
	$table_p = $table."_pages";
	$table_a = $table."_acces";
	$table_host = $table."_host";
	$table_c = $table."_country";
	$table_hour = $table."_hour";
	$table_day = $table."_day";
	$table_os = $table."_os";
	$table_b = $table."_browser";
	$table_k = $table."_keyword";
	$table_r = $table."_referrer";
	$table_retention = $table."_retention";
	//
	$hour = date("H", $time);
	$day = date("w", $time);
	$host = $ip;
	$country = ip2c($ip);
	$datestring = date("Y-m-d",$time);
	$monthstring = date("Y-m",$time)."-01";
	$date = date("Y-m-d H:i:s",$time);
	//
	$c = mysql_connect("$server","$user","$password") or die("<br>Can not connect to database");
	$db = mysql_select_db("$base",$c) or die("<br>Can not connect to database");
	$conf = read_config($config_table, $c);
	$save_host = $conf[save_host];
	$os_id =  $conf[os_id];
	$os_label = $conf[os_label];
	$browser_id = $conf[browser_id];
	$browser_label = $conf[browser_label];
	$engine_id = $conf[engine_id];
	$engine_url = $conf[engine_url] ;
	$engine_kwd = $conf[engine_kwd];
	$blacklist= $conf[blacklist];

	// (We replace all // with / in the page url)
	$page = preg_replace("/\/+/", "/", $page);
	// A problem with the index, we have to get all of them with the "/"
	$page = ereg_replace ("index.html$", "", $page);
	$page = ereg_replace ("index.shtml$", "", $page);
	$page = ereg_replace ("index.php$", "", $page);
	$page = ereg_replace ("index.php3$", "", $page);
	$page = ereg_replace ("index.php4$", "", $page);
	$page = ereg_replace ("index.php5$", "", $page);
	// SPECIAL ZONEO: / Becomes index.php This should be fixed... FIX ME!
	$isindex = substr($page, -1);
	if ($isindex == "/") {
		$page = $page."index.php";
	}

	// Find out if this page has been audited yet, and get the index
	$pageid = pageid($table_p, $c, $page, $datestring);
	if ($pageid == -1) { break;}

	// Hour and day of the week
	$test = updateCount($table_hour, $c, $hour);
	if ($test == -1) { break;}
	$test = updateCount($table_day, $c, $day);
	if ($test == -1) { break;}

	// Host
	$cleanref = cleanText($referer);
	$sql3 ="INSERT INTO `$table_host` VALUES ('$date', '$host', '', '$page','$cleanref','$agent')";
	$res3 = mysql_query($sql3,$c);
	if ($res3 != 1) {
		if ($DEBUG == 1) {echodebug("Could not insert host! <br>Query was $sql3");}
		break;
	}

	// Referrer, search engines, keywords
	$how = 0; // how=0: not know, how=1: link inside site, how=2: SE, how=3: referer
	if ($referer != "") {
		if ((preg_match("/$site/i", $referer))) {
			// if link from within the site do nothing, otherwise, check
			$how = 1;
			if ($debugit) {
				echo "<br>We have a match between $site and $referer";
			}
		} else {
			$keywords = "";
			$keywordsArray = ExtractKeywords($referer,$engine_id,$engine_url,$engine_kwd,$pageid,$debugit);
			if ($keywordsArray != "") {
				// search engine
				$how = 2;
				$engine = array_pop($keywordsArray);
				foreach ($keywordsArray as $value) {
					$keywords .=$value." ";
				}
				$keywords = cleanText($keywords);
				$test = addSEngine($table_k, $c, $engine, $keywords, $date,$pageid);
				if ($test == -1) { break;}
				if ($debugit) {
					echo "<br>We have a search engine hit with $engine and $keywords";
				}
			} else {
				// not a search engine, it's a link, we check the black list
				$test = 1;
				foreach ($blacklist as $black) {
					// Is url matching the one in the black list
					$pos = strpos($referer,$black);
					if ($pos !== false) {
						$test = 0;
						break;
					}
				}
				if ($test == 1) {
					$how = 3;
					$test = addReferrer($table_r, $c, $referer, $date,$pageid);
					if ($test == -1) { break;}
					if ($debugit) {
						echo "<br>We have a referer with $referer";
					}
				} else {
					if ($debugit) {
						echo "<br>We have a blacklisted referer with $referer";
					}
				}
			}
		}
	}

	// Acces
	$test = addDB_LDC($table_a,$c,$datestring,$pageid);
	if ($test == -1) { break;}

	// Agent and OS
	list($wb,$os)=split(";",ExtractAgent($agent,$browser_id,$browser_label,$os_id,$os_label));
	$test = addDB_LDC($table_os,$c,$monthstring,$os);
	if ($test == -1) { break;}
	$test = addDB_LDC($table_b,$c,$monthstring,$wb);
	if ($test == -1) { break;}

	// Country, only if the agent is not a search engine...
	if (!(preg_match("/Crawler/i", $wb))) {
		if (!(preg_match("/Google/i", $wb))) {
			$test = addDB_LDC($table_c,$c,$monthstring,$country);
			if ($test == -1) { break;}
		}
	}

	// Cleanup the host table, we do not want that many... Just keep the last ones.
	$req3 = "SELECT COUNT(*) as count FROM $table_host";
	$res3 = mysql_query($req3,$c);
	$tmp=mysql_fetch_array($res3);
	$tmp2 = $tmp['count'];
	$hostdelete=$tmp2-$save_host;
	if ($hostdelete>0) {
		// For some reason, I can not combine and ORDER BY and a DELETE, so I do them separatly
		// It worked on one server, but not the other one
		$req3 = "ALTER TABLE `$table_host` ORDER BY `date`";
		$res3 = mysql_query($req3,$c);
		$req3 = "DELETE FROM `$table_host` LIMIT $hostdelete";
		$res3 = mysql_query($req3,$c);
		$req3 = "OPTIMIZE TABLE `$table_host` ";
		$res3 = mysql_query($req3,$c);
	}

	// Retention statistics
	$test = retention_stats($table_retention, $host,$time,$c);
	if ($test == -1) { break;}

	// Close database
	@mysql_close ($c);

	$timeend = getmicrotime();
	$temps = $timeend-$timestart;
	if ($DEBUG == 1) {echodebug("It took $temps seconds to log...");}
}

?>